---
title: "Как SelfPrivacy автоматизирует управление сервером"
linkTitle: "Автоматизация SelfPrivacy"
date: 2023-04-27T
weight: 2
description: >
    Как SelfPrivacy автоматизирует управление сервером.
---

Self-hosted означает "самостоятельное размещение" или "сам себе хостинг". Это когда айтишники не используют популярные централизованные сервисы вроде "бесплатного" гугла, а устанавливают их на своих или арендованных серверах (VPS). 

Self-hosted обеспечивает полную приватность данных, в том числе метаинформации. Но и налагает обязательства по самостоятельной эксплуатации такой системы:

- Надо настроить домен для приложения и TLS-сертификат
- Нужно позаботиться о безопасности сервера
- Не пропустить критическое обновление безопасности
- Делать регулярное резервное копирование.
- Следить, чтобы диск не переполнился
- Создавать и удалять пользователей сервисов

Айтишнику задачи посильны, хоть и хлопотны. А для остальных почти неподъемные. Задача SelfPrivacy App максимально упростить этот процесс. Пользователю не нужно использовать консоль или быть квалифицированным специалистом. SeflPrivacy автоматизирует это для вас.

## Управление доменом - полная автомазация
После того как вы настроете домен на CloudFlare, а API-ключ скопируете в приложение SelfPrivacy — ваш домен управляется полностью автоматически:
- Создаются записи для всех сервисов
- Обновятся в случае необходимости
Вам остаётся только раз в год оплачивать домен у своего регистратора. Не забывайте проверять свой электронный почтовый ящик.

## Управление сертификатами - полная автомазация
Безопасность взаимодействия с вашим сереров обеспечивает TLS ≥ v.1.2, как в банках. Для этого SelfPrivacy использует сертификат Let's Ecncypt, самого популярного в мире провайдера, которому доверяют миллионы веб-порталов.
...

## Обновление операционной системы вашем сервере - полная автомазация
Единожды настроенный сервер не является полностью безопасным. В сервисах со временем могут обнаружиться ошибки, и сервер станет подвержен взлому. К сожалению, это не такое уж редкое явление. Поэтому ответственные IT-специалисты регулярно обновляют свои сервера. SelfPrivacy App делает это за вас.
- системные обновления
- Мажорный релиз NixOS

## Обновление приложения SelfPrivacy на вашем сервере - частичная автомазация
SelfPrivacy состоит из двух частей — это приложение на вашем устройстве, SelfPrivacy App, например мобильном телефоне. SP App управляет вашими сервис-провайдерами и вашим SelfPrivacy сервером. Для этого на стороне сервера работает SelfPrivacy API backend демон. Он тоже требует обновления, например, когда мы добавляем функционал или исправляем ошибки.
Обновление зачастую происходит автоматически, однако иногда нужно вручную подтвердить обновление конфигурации системы, чтобы новые функции SP API заработали.

## Обновление SelfPrivacy App - полная автомазация
SP APP грубо говоря — это набор инструкций, которые меняют что-то в сервере. Его вообще можно не обновлять, работа сервера после первичной настройки никак не влияет на работоспособность сервисов на вашем сервере. Тем не менее мы каждый день стараемся что-то автоматизировать, исправить, добавить новых функций.
Обновления SP APP происходит автоматически из репозитория, например F-Droid, в скором будущем App Store и Google Play.

## Управление ресурсами сервера - частичная автомазация
Когда пользователей или сервисов становится много. Сервер может начать тормозить.
Через приложение можно отслеживать текущее потребление ресурсов, а вскоре можно будет и заказать апгрейд виртуальной машины.

## Управление диском - частичная автомазация
Приложение отслеживание состояние дисков сервера и позволяет переносить данные между ними. Если раздел расширяем, приложение может автоматически заказать больше места после подтверждения пользователя.

## Резевные копии - полная автомазация
Резервные копии позволяют и восстановить сломанные сервер, и мигрировать с одного сервера на другой. Все резервные копии зашифрованы, под капотом мы используем Restic. Данные каждого сервиса копируются по отдельности.
Резервное копирование также может проводиться автоматически с заданной пользователем периодичностью.

## Управление пользователями - частичная автомазация
У каждого сервиса есть свой интерфейс администратора, который позволяет управлять пользователями. Однако мы работаем над тем, чтобы интегрировать этот функционал в приложение и автоматически создавать пользователей из общего списка.

## Ручное управление через ssh (expert) - ручные операции
В целях безопасности доступ к администрированию SelfPrivacy сервера через ssh отключен. Это уменьшает поверхность возможной атаки. Доступ к консоли нужен в исключительных случаях:
- Ошибка обновления, или исправление непредвиденных ситуаций
- Тюнинг сервера, если вы опытный пользователь NixOS и хотите самостоятельно донастроить SelfPrivacy Server под свои нужды.
При обычной эксплуатации пользователю не нужно использовать ssh-администрирование через консоль.
Мы работаем над тем, чтобы общую конфигурацию SelfPrivacy можно было расширить собственными файлами Nix, которые не будут мешать автоматическим обновлениям.

## Система очень сложная, почему она приватная?
В отличие от Cloudron, наших коммерческих единомышленников, все операции происходят между вашим приложением, вашим сервером и вашими сервис-провадерами без участия SelfPrivacy. Ваша копия SelfPrivacy App полностью автономна и независима в управлении вашей инфраструктурой. Никакая информация о вашем взаимодействии с вашей инфраструктурой не попадает к SelfPrivacy. Все резервные копии ваших сервисов покидают ваш сервер в полностью зашифрованном виде. Подробнее в политике приватности.